﻿/* ============================================================
* Author:       liubingsheng
* Time:         2016/11/29 14:52:25
* FileName:     RedisSystem
* Purpose:      Redis
* =============================================================*/

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Utility
{
    /// <summary>
    /// List扩展
    /// </summary>
    public static class ListExtension
    {
        /// <summary>
        /// 安全获得范围
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="self"></param>
        /// <param name="range"></param>
        /// <returns></returns>
        public static List<T> SafeGetRange<T>(this List<T> self, PageRange pageRange)
        {
            List<T> lstResults = new List<T>();

            int startIndex = pageRange.Start - 1;
            int endIndex = pageRange.End - 1;

            if (startIndex >= self.Count || endIndex >= self.Count)
            {
                return lstResults;
            }

            if (startIndex < 0 || endIndex < 0)
            {
                return lstResults;
            }

            if (startIndex > endIndex)
            {
                return lstResults;
            }

            int count = endIndex - startIndex + 1;
            return self.GetRange(startIndex, count);
        }
    }
}
